<?PHP

require_once("wetter_conf.php");

$configf[7] = './';

function myfwrite($file,$towrite,$mode)
{
	global $cache,$file_counter,$config;

	$set_chmod = 0;

	if(!file_exists($file)) $set_chmod = 1;
	$fp = fopen($config[7].$file,$mode.'b') or die("file error...!");
	flock($fp,LOCK_EX);
	if(!is_array($towrite))
	{
		fwrite($fp,$towrite);
	}
	else
	{
		for($i = 0; $i < sizeof($towrite); $i++)
		{
			fwrite($fp,$towrite[$i]);
		}
	}
	flock($fp,LOCK_UN); fclose($fp);
	if($set_chmod == 1)
	{
		@chmod($config[7].$file,0777);
	}
	if($mode == "w") $cache['files'][$file] = $towrite;
	else
	{
		$file_counter++;
		$cache['files'][$file] = @file($config[7].$file);
	}
}


function mutate($text)
{
	$text = str_replace("\t"," ",$text);
	$text = stripslashes(htmlspecialchars($text));
	return $text;
}

function translate($text)
{
	$search = file("wettervars/translate.var");

	for($i = 0; $i < count($search); $i++)
	{
		$replace = explode(",",$search[$i]);
		$text = str_replace(trim(chop($replace[0])),trim(chop($replace[1])),$text);
	}
	return $text;
}

$kuer_zl = file("wettervars/".$flugdaten_von."_kuerzel.var");

// auf gesetzte anzahl begrenzen
for($i = 0; $i <= $anzahl; $i++)
{
	$kuerzl[] = $kuer_zl[$i];
}
unset($kuer_zl);


foreach($kuerzl as $element)
{
	$ending = explode("\t",$element);

	if(!$wetter = file("http://weather.noaa.gov/pub/data/observations/metar/decoded/".trim(chop($ending[0])).".TXT"))
	{
		continue;
	}

	else
	{

		$mph_to_kmh = 1.613;

		// alle wetter daten auslesen und den müll erst mal mitnehmen (aufbereitet wird das dann
		$cnt = 0;

		foreach($wetter as $element)
		{
			$suchen = strtolower(mutate(strip_tags($element)));

			if(trim(chop($suchen)) != "")
			{
				$suche[$cnt] = $suchen;
				$cnt++;
			}
		}

		if(isset($_GET['show'])) echo $ending[0]."<br><br>";

		// sicht und das andere zeugs
		for($i = 0; $i < count($suche); $i++)
		{
			if(stristr($suche[$i],"wind")) $wind = $suche[$i];
			if(stristr($suche[$i],"temperature")) $temperat = $suche[$i];
			if(stristr($suche[$i],"visibility")) $sicht = $suche[$i];
			if(stristr($suche[$i],"sky conditions")) $wolken = $suche[$i];
			if(stristr($suche[$i],"windchill")) $chill = $suche[$i];
			if(stristr($suche[$i],"dew point")) $taupunkt = $suche[$i];
			if(stristr($suche[$i],"relative humidity")) $feuchte = $suche[$i];
			if(stristr($suche[$i],"pressure (altimeter)")) $druck = $suche[$i];

			if(isset($_GET['show'])) echo $i." --->".$suche[$i]."<br>";
		}
		// name:
		$von_wo = explode("(",$wetter[0]);
		$vonwo = $von_wo[0];

		if(isset($_GET['show']))
		{
			echo "<br>";
			echo "web ausgelesen:<br>";
			echo "von:".$vonwo."<br><br>";
			echo "wind:".$wind."<br>";
			echo "sicht:".$sicht."<br>";
			echo "wolken".$wolken."<br>";
			echo "temp:".$temperat."<br>";
			echo "chill".$chill."<br>";
			echo "taupunkt:".$taupunkt."<br>";
			echo "feucht:".$feuchte."<br>";
			echo "druck:".$druck."<br>";
		}

		$druck = str_replace("pressure (altimeter):","",$druck);
		$wind = str_replace("wind:","",$wind);
		$wolken = str_replace("sky conditions:","",$wolken);

		// das ergebnis vorbereiten
		// wind

		if(stristr($wind,"variable"))
		{
			$wind = str_replace("variable at", "variabel (360 degrees) at",$wind);
		}

		if(stristr($wind,"calm"))
		{
			$wind = str_replace("calm", "calm (360 degrees) at 0 mph",$wind);
		}



		$w1 = explode("(",$wind);
		$w_vor = trim(chop($w1[0]));
		$w_vor = translate($w_vor);
		$w_vor = str_replace(" ","",$w_vor);

		if($w_vor == "") $w_vor = 'still';
		$wnach = explode("at",$w1[1]);
		$wwnach = explode("mph",$wnach[1]);
		$ww_nach = trim(chop($wwnach[0]));
		$wind = strtoupper($w_vor)." ".number_format(($ww_nach * $mph_to_kmh),1,",",".")." kmh";

		// sicht
		if(stristr($sicht,"than"))
		{
			$view = explode("than",$sicht);
		}
		else
		{
			$view[0] = '';
			$view[1] = $sicht;
		}

		$v1 = explode("mile",$view[1]);
		$v = str_replace(" ","",$v1[0]);
		$v = trim(chop($v));
		$sicht = "ca. ".number_format(($v * 1.609344),1,",",".")." km";

		// wolken
		$wolken = translate($wolken);

		// temperaturen und luftdruck
		// (TF − 32) / 1,8
		$temp = @explode("(",$temperat);
		$tautmp = @explode("(",$taupunkt);
		$chil = @explode("f",$chill);
		$druc = @explode("(",$druck);

		if(trim(chop($chil[0])) != "") $chill = str_replace(" ","",trim(chop(number_format((($chil[0]-32)/1.8),0,",","."))))."&deg; C";
		else $chill = "";

		$temp2 = @explode(")",$temp[1]);
		$tautemp2 = @explode(")",$tautmp[1]);

		$temperat = $temp2[0];
		$taupunkt = $tautemp2[0];

		$druck = str_replace("hpa)","",trim(chop($druc[1])))." hPa";

		$text = strftime("%H%M");
		$stunde = substr($text,0,2);
		$minute = substr($text,2,2);

		$last_aufruf = $stunde.":".$minute;

		// überfluessigen text eleminieren:
		$wind = trim(chop(str_replace("wind:","",$wind)));
		$sicht = trim(chop(str_replace("sky conditions:","",$sicht)));
		$taupunkt = trim(chop(str_replace("dew point:","",$taupunkt)));
		$feuchte = str_replace("relative humidity:","",$feuchte);

		$towrite = trim(chop($wind))."\n".trim(chop($sicht))."\n".trim(chop($wolken))."\n".trim(chop($temperat))."\n".trim(chop($taupunkt))."\n".trim(chop($chill))."\n".trim(chop($feuchte))."\n".trim(chop($druck))."\n".$last_aufruf."\n".$vonwo."\n";

		myfwrite("wettervars/".trim(chop($ending[0])).".var",$towrite,'w');


		if(isset($_GET['show']))
		{
			echo "<br>";
			echo "web ausgewertet:<br>";
			echo "von:".$vonwo."<br><br>";
			echo "wind:".$wind."<br>";
			echo "sicht:".$sicht."<br>";
			echo "wolken".$wolken."<br>";
			echo "temp:".$temperat."<br>";
			echo "chill".$chill."<br>";
			echo "taupunkt:".$taupunkt."<br>";
			echo "feucht:".$feuchte."<br>";
			echo "druck:".$druck."<br>";
			echo "<br><br><hr></hr>";
		}
	}
}
?>
